#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
	
#define TAILLE_MAX_PHRASE 	128
#define	FICHIER_PIPE1		"/tmp/testfifo1"
#define	FICHIER_PIPE2		"/tmp/testfifo2"
	
/* fonction qui inverse une chaine de caracteres */
void retourne_phrase(char p[])
{
	char    tempo[TAILLE_MAX_PHRASE];
	int     i;
	int     l = strlen(p);
	for (i=0; i < l; i++)
		tempo[i] = p[l-i-1];
	tempo[l]='\0';
	strcpy(p, tempo);
}
	

int main(int argi, char *argv[])
{
	char	phrase[TAILLE_MAX_PHRASE];
	int	tube1;
	int	tube2;
	mkfifo(FICHIER_PIPE1, S_IRWXU|O_CREAT);
	mkfifo(FICHIER_PIPE2, S_IRWXU|O_CREAT);
	tube1 = open(FICHIER_PIPE1, O_RDONLY);
	if (tube1 < 0)
	{
		fprintf(stderr, "Erreur à l'ouverture de pipe2 en lecture...\n");
		exit(-1);
	}
	tube2 = open(FICHIER_PIPE2, O_WRONLY);
	if (tube2 < 0)
	{
		fprintf(stderr, "Erreur à l'ouverture de pipe1 en écriture...\n");
		exit(-1);
	}
	/* on attend la phrase qu'il faudra inverser... */
	read(tube1, phrase, 128);
	printf("REPONDEUR: Phrase recue=%s\n", phrase);
	/* on retourne la phrase */
	retourne_phrase(phrase);
	/* et on envoie la réponse */
	write(tube2, phrase, strlen(phrase)+1);
	printf("REPONDEUR: Phrase envoyee=%s\n", phrase);
	close(tube1);
	close(tube2);
	return(0);
}
